function [Out,bDs,Error]=set_mtimes(N,verbose,varargin)
  % example of 'set_fun' function used in bench
  p = inputParser;
  p.KeepUnmatched=true; 
  p.PartialMatching=false;
  p.addParamValue('ld',[2,2],@(x) ismember(length(x),[1,2]));
  p.addParamValue('rd',[2,2],@(x) ismember(length(x),[1,2]));
  p.addParamValue('fprintf',@(varargin) fprintf(varargin{:}));
  p.addParamValue('ltype','amat',@(s) ismember(lower(s),{'amat','mat','array1d','constant'}));
  p.addParamValue('rtype','amat',@(s) ismember(lower(s),{'amat','mat','array1d','constant'}));
  p.addParamValue('lclass','double');
  p.addParamValue('rclass','double');
  p.addParamValue('lcomplex',false,@islogical);
  p.addParamValue('rcomplex',false,@islogical);
  p.parse(varargin{:});
  R=p.Results;
  %mattype=R.mattype;
  R.ltype=lower(R.ltype);R.rtype=lower(R.rtype);
  Fprintf=R.fprintf;
  varargin=fc_tools.utils.deleteCellOptions(varargin,p.Parameters);
  assert( strcmp(R.ltype,'amat') || strcmp(R.rtype,'amat') )
  if verbose, Fprintf('# 1st parameter is :\n');end
  [X,~,~]=fc_amat.benchs.set_datas(N,verbose,'d',R.ld,'type',R.ltype,'class',R.lclass,'complex',R.lcomplex,varargin{:});
  if verbose, Fprintf('# 2nd parameter is :\n');end
  [Y,~,~]=fc_amat.benchs.set_datas(N,verbose,'d',R.rd,'type',R.rtype,'class',R.rclass,'complex',R.rcomplex,varargin{:});
  Error={};
  bDs{1}=fc_bench.bdata('N',N,'%d',10);
  Out={X{1},Y{1}};
end
