function Ba=barycenters(q,me,varargin)
  p = inputParser;
  p.addParamValue('type','simplex', @(x) ismember(lower(x),{'simplex','orthotope'}));
  p.addParamValue('order',1);
  p.addParamValue('m',[]);
  p.parse(varargin{:});R=p.Results;
  [d,nq]=size(q);[nelts,nme]=size(me);
  if isempty(R.m)
    Lm=0:d;
    Nh=fc_hypermesh.getNbOfNodesByElt(R.order,Lm,'type',R.type);
    j=find(Nh==nelts);
    assert( length(j)==1, 'Unable to find m-dimension')
    m=Lm(j);
  else
    m=R.m;
    assert( fc_hypermesh.getNbOfNodesByElt(R.order,m,'type',R.type) == nelts )
  end
  Idx=fc_hypermesh.VerticesIdxRef(m,R.order,'type',R.type);
  Ba=zeros(d,nme);
  for i=Idx
    Ba=Ba+q(:,me(i,:));
  end
  Ba=Ba/length(Idx);
end
