function Th=readgmsh4_1(gmsh_file,dim,d,isPhysLabel,trans)
%    p = inputParser; 
%    p=AddParamValue(p,'dim', 2, @isfloat ); % default - dim=-1 has
%                                         ;   % no effect
%    p=AddParamValue(p,'PhysLabel', true, @islogical ); % Physical Label or Geometrical Label                                          
%    p=Parse(p,varargin{:});
%    dim=p.Results.dim;
%    isPL=p.Results.PhysLabel;
   % import fc_simesh.siMeshElt not yet implemented in Octave 5.2.0
  Th=fc_simesh.siMesh();
  Th.dim=dim;
  Th.d=max(d);
  
  G=fc_oogmsh.ooGmsh4(gmsh_file);
  G.q=fc_simesh.tools.trans_q(G.q,trans);
  [q,tags]=G.get_q();
  q=q(:,tags);
  if dim==2 && sum(abs(q(3,:)))>0
    [p,f,e]=fileparts(gmsh_file);
    fprintf('  Mesh %s%s is a %d-dimensional mesh\n    Force dimension to %d\n',f,e,G.dim,G.dim)
    dim=3;
    d=dim:-1:dim-1;
  end
  if Th.dim==2,q=q([1,2],:);end
%    if ~isempty(trans) 
%      switch nargin(trans)
%        case 1
%          q=trans(q);
%        case 2
%          q=trans(q(1,:),q(2,:));
%        case 3
%          q=trans(q(1,:),q(2,:),q(3,:));
%        otherwise  
%          error('trouble with trans option')
%      end
%      
%    end
  
  %assert(max(G.orders)==1);
  Th.dim=dim;
  Th.d=max(d);
  Th.toGlobal=G.toGlobal;
  Th.nq=length(G.toGlobal);
  Th.toParent=G.toGlobal;
  Th.toParents{1}=G.toGlobal;
  Th.nqParents(1)=G.nq;
  
  if isPhysLabel
    getTags=@(x) G.get_PhysicalTags(x);
    get_localmesh=@(type,tag) G.get_localmesh_PhysicalTag(type,tag);
  else
    getTags=@(x) G.get_ElementaryTags(x);
    get_localmesh=@(type,tag) G.get_localmesh_ElementaryTag(type,tag);
  end
  
  dim=G.dim;
  % G.Elements.ElementTypes
  if dim==3  
    Elt_List=[4,2,1,15]; % uniquement order 1
  else
    Elt_List=[2,1,15];
  end
  for type=Elt_List
    etd=fc_oogmsh.gmsh.elm_type_desc(type);
    for tag=getTags(type)
      [q,me,toGlobal]=get_localmesh(type,tag);
      
      label=tag;
      nqGlobal=length(toGlobal);
      geolab=[];
      partlab=[];
      Th.sTh{end+1}=fc_simesh.siMeshElt(dim,etd.d,label,q,me,toGlobal,nqGlobal,geolab,partlab);
      Th.sThphyslab(end+1)=tag;
      Th.sThsimp(end+1)=etd.d;
      Th.sThlab(end+1)=tag;
      %keyboard
      %Th=AddsiMeshElts(Th,etd.d,q,size(me,2),me,toGlobal,'geolab',geolab,'partlab',partlab);
    end
  end

  Th.d=max(Th.sThsimp);
  Th.sThphyslab=Th.sThlab(Th.find(Th.d));
end

%  function q=trans_q(q,trans)
%    if ~isempty(trans) 
%      switch nargin(trans)
%        case 1
%          q=trans(q);
%        case 2
%          q=trans(q(1,:),q(2,:));
%        case 3
%          q=trans(q(1,:),q(2,:),q(3,:));
%        otherwise  
%          error('trouble with trans option')
%      end
%    end
%  end
