function plotiso2D(varargin)
  close all % :start:
  meshfile=fc_oogmsh.gmsh.buildmesh2d('condenser11',25,varargin{:});
  Th=fc_simesh.siMesh(meshfile);
  u=Th.eval(@(x,y) 5*exp(-3*(x.^2+y.^2)).*cos(x).*sin(y));
  fc_tools.graphics.monitors.onGrid(2,2);
  figure(1)
  fc_siplt.plotmesh(Th,'d',1,'color','k')
  hold on;axis off;axis image;
  fc_siplt.plotiso(Th,u,'isocolorbar',true)
  figure(2)
  fc_siplt.plot(Th,u,'plane',true,'FaceAlpha',0.7)
  hold on;axis off;axis image;shading interp;
  fc_siplt.plotiso(Th,u,'plane',true,'LineWidth',1.5)
  colorbar
  figure(3)
  fc_siplt.plot(Th,u,'FaceAlpha',0.7)
  view(3)
  shading interp;hold on;axis off;axis image;
  fc_siplt.plotiso(Th,u,'niso',15,'LineWidth',1.5)
  colorbar
  figure(4)
  fc_siplt.plot(Th,u,'plane',true)
  shading interp;hold on;axis off;axis image;
  fc_siplt.plotiso(Th,u,'isorange',0, 'LineWidth',1.5, 'color','w')
  fc_siplt.plotiso(Th,u,'isorange',[-1,1], 'LineWidth',1.5, 'color','k','plane',true)
  axis off;axis image;colorbar % :end:
end
